package project.sichuan.suiningshizxyy;

import com.ibatis.sqlmap.client.SqlMapClient;
import com.znshkj.mzyf.main.CCDatas;
import com.znshkj.mzyf.main.CoreControl;
import com.znshkj.mzyf.main.GlobalData;
import com.znshkj.mzyf.main.HkcModbus;
import com.znshkj.mzyf.main.IbatisSqlMapClient;
import com.znshkj.mzyf.main.OutMsg;
import com.znshkj.mzyf.main.SecretDate;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.time.LocalTime;
import java.util.Date;
import java.util.HashMap;
import project.face.FReadOrder;
import project.sichuan.suiningshizxyy.BasketThread;
import project.sichuan.suiningshizxyy.CancelOrder;
import project.sichuan.suiningshizxyy.DataStatThread;
import project.sichuan.suiningshizxyy.DispFinishT;
import project.sichuan.suiningshizxyy.OrderInfoMergeT;
import project.sichuan.suiningshizxyy.PlcBase;
import project.sichuan.suiningshizxyy.QueryDisposeStockT;
import project.sichuan.suiningshizxyy.ReadDrugInfoThread;
import project.sichuan.suiningshizxyy.StatCollectThread;
import project.sichuan.suiningshizxyy.work.WorkRunThread;

public class ReadOrderInfoT extends FReadOrder implements Runnable {

   private boolean connState = false;
   private static Connection hisCONN;
   SqlMapClient sqlMap = IbatisSqlMapClient.newInstence();
   HashMap pbdruginfo = new HashMap();


   public ReadOrderInfoT() {
      OutMsg.println("标准：接口表配置参数读取成功：");
      OutMsg.println("标准：接口表配置1参数：dbType=" + getDbType() + ",dbIP=" + getDbIP() + ",dbName=" + getDbName() + ",dbUserName=" + getDbUserName() + ",dbPWD=" + getDbPWD());
      OutMsg.println("标准：接口表配置2参数：dbType2=" + getDbType2() + ",dbIP2=" + getDbIP2() + ",dbName2=" + getDbName2() + ",dbUserName2=" + getDbUserName2() + ",dbPWD2=" + getDbPWD2());
      OutMsg.println("标准：启动与呼叫系统之间的Socket连接");
   }

   public static void main(String[] args) {
      SqlMapClient sqlMap = IbatisSqlMapClient.newInstence();
      Connection conn = null;

      try {
         conn = sqlMap.getDataSource().getConnection();

         try {
            Statement var4 = conn.createStatement();
            var4.execute("insert into order_info(patient_id,order_no) values(\'1733816\',\'1550197\')");
            conn.commit();
         } catch (Exception var41) {
            var41.printStackTrace();
            conn.rollback();
         }

         Thread.sleep(20000000L);
      } catch (Exception var5) {
         ;
      }

   }

   public boolean createSqlConn() {
      try {
         switch(getDbType()) {
         case 1:
            Class.forName("com.mysql.jdbc.Driver");
            if(GlobalData.getStatedbIP() == 1) {
               hisCONN = DriverManager.getConnection("jdbc:mysql://" + getDbIP() + ":3306/" + getDbName() + "?useUnicode=true&characterEncoding=utf8", getDbUserName(), getDbPWD());
            } else {
               hisCONN = DriverManager.getConnection("jdbc:mysql://" + getDbIP2() + ":3306/" + getDbName2() + "?useUnicode=true&characterEncoding=utf8", getDbUserName2(), getDbPWD2());
            }
            break;
         case 2:
            Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
            if(GlobalData.getStatedbIP() == 1) {
               hisCONN = DriverManager.getConnection("jdbc:microsoft:sqlserver://" + getDbIP() + ":1433;DatabaseName=" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               hisCONN = DriverManager.getConnection("jdbc:microsoft:sqlserver://" + getDbIP2() + ":1433;DatabaseName=" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
            break;
         case 3:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            if(GlobalData.getStatedbIP() == 1) {
               hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521:" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP2() + ":1521:" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
            break;
         case 4:
            Class.forName("oracle.jdbc.driver.OracleDriver");
            if(GlobalData.getStatedbIP() == 1) {
               hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP() + ":1521/" + getDbName(), getDbUserName(), getDbPWD());
            } else {
               hisCONN = DriverManager.getConnection("jdbc:oracle:thin:@" + getDbIP2() + ":1521/" + getDbName2(), getDbUserName2(), getDbPWD2());
            }
         }

         OutMsg.println("标准：连接到HIS数据库的JDBC连接建立成功:" + hisCONN.toString());
         this.connState = true;
         return true;
      } catch (Exception var2) {
         OutMsg.println(var2);
         OutMsg.println("标准：连接HIS数据库失败！");
         this.connState = false;
         if(GlobalData.getStatedbIP() == 1) {
            GlobalData.setStatedbIP(2);
         } else {
            GlobalData.setStatedbIP(1);
         }

         return false;
      }
   }

   public void pbDrugInfoInit() {
      Connection conn = null;

      try {
         conn = this.sqlMap.getDataSource().getConnection();
         PreparedStatement var5 = conn.prepareStatement("select drug_id from drug_info");
         ResultSet rSet_drug = var5.executeQuery();

         while(rSet_drug.next()) {
            String drug_id = rSet_drug.getString("drug_id").trim();
            this.pbdruginfo.put(drug_id, drug_id);
         }

         rSet_drug.close();
         var5.close();
         conn.close();
      } catch (SQLException var51) {
         OutMsg.println(var51);
      }

   }

   public int openTcpServer() {
      try {
         if(!"".equals(GlobalData.getTcpServerIp())) {
            OutMsg.println("连接TcpServer......");
            HkcModbus var2 = new HkcModbus();
            var2.setSocketID("TS");
            var2.setServerIP(GlobalData.getTcpServerIp());
            var2.setServerPort(GlobalData.getTcpServerPort());
            if("".equals(var2.operateModebus("", "AA00EE", true))) {
               return -1;
            }

            OutMsg.println("TcpServer连接成功");
            CCDatas.socHashMap.put("TS", var2);
            return 1;
         }
      } catch (Exception var21) {
         var21.printStackTrace();
         OutMsg.println(var21);
      }

      return -3;
   }

   public void timeReporting() {
      LocalTime currentTime = LocalTime.now();
      LocalTime startTime = LocalTime.of(8, 0, 0);
      LocalTime endTime = LocalTime.of(18, 0, 0);
      if(currentTime.isAfter(startTime) && currentTime.isBefore(endTime)) {
         OutMsg.println("当前时间在8点到18点之间,系统默认为签到模式。");
         SecretDate.setAutomaticReporting(1);
      } else {
         OutMsg.println("当前时间不在8点到18点之间,系统默认为自动模式。");
         SecretDate.setAutomaticReporting(0);
      }

   }

   public void run() {
      int rFlag = this.openTcpServer();
      if(rFlag == -3) {
         OutMsg.println("ERROR ************没有配置TCPServerIP地址");
      } else if(rFlag == -1) {
         OutMsg.println("ERROR ************连接智能药筐控制器失败！！");
      }

      this.timeReporting();
      (new Thread(new PlcBase())).start();
      (new Thread(new WorkRunThread())).start();
      (new Thread(new ReadDrugInfoThread())).start();
      (new Thread(new OrderInfoMergeT())).start();
      (new Thread(new BasketThread())).start();
      (new Thread(new DataStatThread())).start();
      (new Thread(new StatCollectThread())).start();
      this.pbDrugInfoInit();
      int topID = 0;

      while(!this.connState && !this.createSqlConn()) {
         try {
            Thread.sleep(2000L);
         } catch (InterruptedException var39) {
            var39.printStackTrace();
         }
      }

      Date currentTime = new Date();
      SimpleDateFormat formatter = new SimpleDateFormat("yyyyMMdd");
      String dateString = formatter.format(currentTime);

      try {
         if(CCDatas.sysParamHashMap.get("TOP_ID") == null) {
            (new CoreControl()).createTopID(dateString + "_0");
         } else if(((String)CCDatas.sysParamHashMap.get("TOP_ID")).indexOf(dateString) > -1) {
            topID = Integer.parseInt(((String)CCDatas.sysParamHashMap.get("TOP_ID")).substring(((String)CCDatas.sysParamHashMap.get("TOP_ID")).indexOf("_") + 1));
         }
      } catch (Exception var38) {
         ;
      }

      String noReadID = "\'\'";
      Connection conn = null;

      while(true) {
         Date currentTime1 = new Date();
         dateString = formatter.format(currentTime1);

         while(!this.connState && !this.createSqlConn()) {
            try {
               Thread.sleep(2000L);
            } catch (InterruptedException var331) {
               var331.printStackTrace();
            }
         }

         if(noReadID.split(",").length > 50) {
            noReadID = noReadID.substring(noReadID.indexOf(noReadID.split(",")[noReadID.split(",").length - 50]));
         }

         try {
            Statement var33 = hisCONN.createStatement();
            String strTopID = String.valueOf(topID);
            String sqlString = "";
            switch(getDbType()) {
            case 1:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "DATE_FORMAT(now(),\'%Y%m%d\')=DATE_FORMAT(Insert_Time,\'%Y%m%d\')");
               break;
            case 2:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "CONVERT(varchar(12),getdate(),112)=CONVERT(varchar(12),Insert_Time,112) AND datediff(minute, Insert_Time,getdate ()) < 10");
               break;
            case 3:
            case 4:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID);
               break;
            case 5:
            case 9:
               sqlString = getQueryStateSQL().replace("where", "where Pharmacy=\'" + GlobalData.getPharmacyID() + "\' and ").replace("ID>#TOPID#", "(ID>" + strTopID + " or ID in (" + noReadID + "))").replace("#TOPID#", strTopID).replace("to_char(sysdate,\'yyyy-mm-dd\')=to_char(Insert_Time,\'yyyy-mm-dd\')", "date(current　timestamp)=date(Insert_Time)");
            case 6:
            case 7:
            case 8:
            }

            ResultSet rSet;
            for(rSet = var33.executeQuery(sqlString); rSet.next(); (new CoreControl()).updateTopID(dateString + "_" + topID)) {
               int TopID = rSet.getInt("ID");
               String patid = rSet.getString("Patient_ID") == null?rSet.getString("Order_NO"):rSet.getString("Patient_ID");
               int state = rSet.getInt("State");
               String patname = rSet.getString("Patient_Name");
               int windowNO = rSet.getInt("Window_NO");
               String cfxh = rSet.getString("Order_NO");
               String chargeDate = rSet.getString("Charge_Date");
               String his_operater = "";

               try {
                  his_operater = rSet.getString("Operater");
               } catch (Exception var37) {
                  ;
               }

               OutMsg.println("标准：处理ID=" + String.valueOf(TopID) + "的记录 state=" + state);
               switch(state) {
               case 0:
                  OutMsg.println("新开处方：");
                  break;
               case 1:
                  OutMsg.println("标准：处方收费：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\' patname=" + patname + " winno=" + windowNO);
                  conn = this.sqlMap.getDataSource().getConnection();
                  PreparedStatement var42 = conn.prepareStatement("select * from order_info where patient_id=? and order_no=?");
                  var42.setString(1, patid);
                  var42.setString(2, cfxh);
                  ResultSet var43 = var42.executeQuery();
                  if(var43.next()) {
                     var43.close();
                     var42.close();
                     conn.close();
                     OutMsg.println("标准：此患者处方数据已处理过，不在进行处理");
                  } else {
                     var43.close();
                     var42.close();
                     OutMsg.println("标准：遍历此患者(" + patid + ")处方(" + cfxh + ")明细，加入order_detail");
                     PreparedStatement prmt3 = conn.prepareStatement("insert into order_detail(patient_id,Order_no,charge_date,Serial_no,Drug_id,Quantity,Order_unit,Set_Manu_no,Use_Once,Use_Dosage,Use_by,Use_Discrip,Use_Frequ,Use_days,Use_Try,His_Stock_Pos,Use_Self,Doctor_Discrip,Use_Times,Price) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
                     PreparedStatement prmt2 = conn.prepareStatement("insert into order_info(patient_id,order_no,Invoice_NO,Patient_NO,his_id,p_name,recv_date,charge_date,Order_date,win_no,Operator,Doctor_name,Order_Type,Charge_Type,Dept_Name,Disease,sex,age,Sum_Price,state) values(?,?,?,?,?,?,now(),?,?,?,?,?,?,?,?,?,?,?,?,-1)");
                     int detlnb = 0;
                     Statement statement2 = hisCONN.createStatement();
                     ResultSet rSet2 = statement2.executeQuery("select * from HKC_ORDERDETL_VIEW where Order_NO=\'" + cfxh + "\' and Patient_ID=\'" + patid + "\'");

                     while(rSet2.next()) {
                        String var34 = rSet2.getString("Drug_ID").trim();
                        if(this.pbdruginfo.get(var34) == null) {
                           try {
                              Statement var35 = hisCONN.createStatement();
                              ResultSet rSet_drug = var35.executeQuery("select * from HKC_DRUGINFO_VIEW where Drug_ID=\'" + var34 + "\'");

                              while(rSet_drug.next()) {
                                 String ypdm = rSet_drug.getString("Drug_ID").trim();
                                 PreparedStatement prmt_drug = conn.prepareStatement("insert into drug_info(drug_id,drug_name,drug_spec,dosage,pack_unit,manufactory,py_code,yf_stock,drug_type,Cold_storage,Manufactory_id,Back_stock_pos) values(?,?,?,?,?,?,?,?,?,?,?,?)");
                                 prmt_drug.setString(1, ypdm);
                                 prmt_drug.setString(2, rSet_drug.getString("Drug_Name"));
                                 prmt_drug.setString(3, rSet_drug.getString("Drug_Spec"));
                                 prmt_drug.setString(4, rSet_drug.getString("Dosage"));
                                 prmt_drug.setString(5, rSet_drug.getString("Pack_Unit"));
                                 prmt_drug.setString(6, rSet_drug.getString("Manufactory"));
                                 prmt_drug.setString(7, rSet_drug.getString("PY_Code"));
                                 prmt_drug.setString(8, rSet_drug.getString("Pharmacy_Quantity") == null?"":rSet_drug.getString("Pharmacy_Quantity"));
                                 prmt_drug.setString(9, rSet_drug.getString("Drug_Type"));
                                 prmt_drug.setInt(10, Integer.parseInt(rSet_drug.getString("Cold_Storage")));
                                 prmt_drug.setString(11, rSet_drug.getString("Manufactory_ID"));
                                 prmt_drug.setString(12, rSet_drug.getString("Second_StockPos"));
                                 prmt_drug.execute();
                                 conn.commit();
                                 OutMsg.println("[DM] " + prmt_drug.toString());
                                 prmt_drug.close();
                              }

                              rSet_drug.close();
                              var35.close();
                           } catch (Exception var40) {
                              OutMsg.println(var40);
                           }

                           this.pbdruginfo.put(var34, var34);
                        }

                        if(detlnb == 0) {
                           prmt2.setString(1, patid);
                           prmt2.setString(2, cfxh);
                           prmt2.setString(3, "");
                           prmt2.setString(4, "");
                           prmt2.setString(5, "");
                           prmt2.setString(6, patname);
                           prmt2.setString(7, chargeDate);
                           prmt2.setString(8, chargeDate);
                           prmt2.setInt(9, windowNO);
                           prmt2.setString(10, "");
                           prmt2.setString(11, rSet2.getString("Doctor_Name"));
                           prmt2.setString(12, "");
                           prmt2.setString(13, "");
                           prmt2.setString(14, rSet2.getString("Dept_Name"));
                           prmt2.setString(15, rSet2.getString("Disease"));
                           prmt2.setString(16, rSet2.getString("Sex"));
                           prmt2.setString(17, rSet2.getString("Age"));
                           prmt2.setString(18, "");
                        }

                        ++detlnb;
                        prmt3.setString(1, patid);
                        prmt3.setString(2, cfxh);
                        prmt3.setString(3, chargeDate);
                        prmt3.setString(4, String.valueOf(detlnb));
                        prmt3.setString(5, rSet2.getString("Drug_ID").trim());
                        prmt3.setString(6, rSet2.getString("Quantity"));
                        prmt3.setString(7, rSet2.getString("Order_Unit"));
                        prmt3.setString(8, "");
                        prmt3.setString(9, rSet2.getString("Use_Once"));
                        prmt3.setString(10, rSet2.getString("Use_Dosage"));
                        prmt3.setString(11, rSet2.getString("Use_By"));
                        prmt3.setString(12, rSet2.getString("Use_Discrip"));
                        prmt3.setString(13, rSet2.getString("Use_Frequ"));
                        prmt3.setString(14, rSet2.getString("Use_Days"));
                        prmt3.setString(15, rSet2.getString("Use_Try"));
                        prmt3.setString(16, "");
                        prmt3.setString(17, String.valueOf(rSet2.getInt("Self_Provide")));
                        prmt3.setString(18, "");
                        prmt3.setString(19, "");
                        prmt3.setString(20, rSet2.getString("Price"));

                        try {
                           prmt3.executeUpdate();
                           conn.commit();
                        } catch (Exception var36) {
                           conn.rollback();
                        }
                     }

                     prmt3.close();
                     if(detlnb > 0) {
                        OutMsg.println(prmt2.toString());

                        try {
                           prmt2.execute();
                           conn.commit();
                        } catch (Exception var351) {
                           OutMsg.println("提交失败：事务回滚");
                           OutMsg.println(var351);
                           conn.rollback();
                        }
                     } else {
                        OutMsg.println("未读到处方明细记录");
                     }

                     prmt2.close();
                     rSet2.close();
                     statement2.close();
                     conn.close();
                  }
                  break;
               case 2:
                  OutMsg.println("标准：处方退费：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\'");
                  (new Thread(new CancelOrder(cfxh, patid))).start();
                  break;
               case 3:
                  OutMsg.println("标准：患者到窗口：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\'" + " fyckh=" + windowNO);
                  (new Thread(new QueryDisposeStockT(patid, rSet.getString("Order_NO").trim(), rSet.getString("Window_NO").trim()))).start();
                  break;
               case 4:
                  OutMsg.println("标准：发药完成：cfxh=\'" + cfxh + "\' patid=\'" + patid + "\' fyckh=\'" + windowNO + "\'");
                  (new Thread(new DispFinishT(patid, cfxh, his_operater))).start();
               }

               if(topID > 0) {
                  for(int var421 = topID + 1; var421 < TopID; ++var421) {
                     String var44 = String.valueOf(var421);
                     if("\'\'".equals(noReadID)) {
                        noReadID = "\'" + var44 + "\'";
                     } else {
                        noReadID = noReadID + ",\'" + var44 + "\'";
                     }
                  }
               }

               if(TopID > topID) {
                  topID = TopID;
               } else {
                  String var431 = String.valueOf(TopID);
                  noReadID = noReadID.replace("\'" + var431 + "\',", "").replace(",\'" + var431 + "\'", "").replace("\'" + var431 + "\'", "\'\'");
               }
            }

            rSet.close();
            var33.close();
         } catch (Exception var41) {
            OutMsg.println("标准：ERROR:读处方异常");
            OutMsg.println(var41);
            this.connState = false;
         }

         try {
            Thread.sleep((long)getWaitTime());
         } catch (InterruptedException var341) {
            var341.printStackTrace();
         }
      }
   }
}
